﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Private ivBackground As B4XView
	Public lblStats As B4XView
	Private BoxSize As B2Vec2
	
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("GameLayout")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
	'Configure the dimensions. Center point is (0, 3) and the visible width is 6 meters.
	X2.ConfigureDimensions(world.CreateVec2(0, 3.5), 8)
	'Load the graphics and add them to the cache.
	'comment to disable debug drawing
	X2.EnableDebugDraw
	CreateStaticBackground
	CreateGround
	BoxSize = X2.CreateVec2(0.5, 1)
	
	Dim CvsMinSize As Int = X2.MetersToBCPixels(Max(BoxSize.X, BoxSize.Y))
	Dim Cvs As B4XCanvas = X2.GraphicCache.GetCanvas(CvsMinSize / X2.BmpSmoothScale)
	Dim r As B4XRect
	r.Initialize(0, 0, X2.MetersToBCPixels(BoxSize.X) + 1, X2.MetersToBCPixels(BoxSize.Y) + 1)
	Dim i As Int
	For Each clr As Int In Array(0xFF2100AB, 0xFFA30000, 0xFFBE00F4)
		i = i + 1
		Cvs.ClearRect(r)
		Cvs.DrawRect(r, clr , True, 0)
		Dim sb As X2ScaledBitmap
		sb.Bmp = Cvs.CreateBitmap.Crop(0, 0, r.Right, r.Bottom)
		sb.Scale = 1
		X2.GraphicCache.PutGraphic("block" & i, Array(sb))
	Next
	X2.GraphicCache.PutGraphic("donut", Array(X2.LoadBmp(File.DirAssets, "Blue_Donut_7.png", 0.5, 0.5, True)))
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale, ivBackground.Height / xui.Scale)
	bc.FillGradient(Array As Int(0xFF006EFF, 0xFFB04700), bc.TargetRect, "TOP_BOTTOM")
	ivBackground.SetBitmap(bc.Bitmap)
End Sub

Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub

Public Sub Tick (GS As X2GameStep)
	If X2.RndFloat(0, 500) < X2.TimeStepMs Then CreateBlock
	If X2.RndFloat(0, 500) < X2.TimeStepMs Then CreateCircle
End Sub

Private Sub CreateGround
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_STATIC 'the engine should not move it
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "ground")
	Dim edge As B2EdgeShape
	edge.Initialize(X2.CreateVec2(-20, 1), X2.CreateVec2(20, 1))
	wrapper.Body.CreateFixture2(edge, 1)
End Sub

Private Sub CreateCircle
	'create the body
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_DYNAMIC 'regular body
	Dim x As Float = X2.RndFloat(X2.ScreenAABB.BottomLeft.X, X2.ScreenAABB.TopRight.X)
	bd.Position = X2.CreateVec2(x, X2.ScreenAABB.TopRight.Y)
	bd.Bullet = True
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "Donut")
	'add fixture
	Dim circle As B2CircleShape
	circle.Initialize(0.25)
	Dim f As B2Fixture = wrapper.Body.CreateFixture2(circle, 1)
	'make the blocks bounce when collided.
	f.Restitution = 0.5
	wrapper.GraphicName = "Donut"
End Sub

Private Sub CreateBlock
	'create the body
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_DYNAMIC 'regular body
	bd.Bullet = True
	Dim x As Float = X2.RndFloat(X2.ScreenAABB.BottomLeft.X, X2.ScreenAABB.TopRight.X)
	bd.Position = X2.CreateVec2(x, X2.ScreenAABB.TopRight.Y)
	Dim wrapper As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "Block")
	'add fixture
	Dim rect As B2PolygonShape
	rect.Initialize
	rect.SetAsBox(BoxSize.X / 2, BoxSize.Y / 2) 'parameters are half width and half height. 
	Dim f As B2Fixture = wrapper.Body.CreateFixture2(rect, 1)
	'make the blocks bounce when collided.
	f.Restitution = 0.5
	wrapper.GraphicName = "Block" & Rnd(1, 4)
End Sub
